9ae3a8
From 36be200f11e87ccd97a54236550be41bc3ec6862 Mon Sep 17 00:00:00 2001
9ae3a8
From: Max Reitz <mreitz@redhat.com>
9ae3a8
Date: Thu, 9 Jan 2014 09:11:13 +0100
9ae3a8
Subject: [PATCH 03/14] qemu-iotests: Snapshotting zero clusters
9ae3a8
9ae3a8
Message-id: <1389131839-12920-4-git-send-email-mreitz@redhat.com>
9ae3a8
Patchwork-id: 56539
9ae3a8
O-Subject: [RHEL-7.0 qemu-kvm PATCH v2 03/14] qemu-iotests: Snapshotting zero clusters
9ae3a8
Bugzilla: 1033490
9ae3a8
RH-Acked-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
RH-Acked-by: Fam Zheng <famz@redhat.com>
9ae3a8
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
9ae3a8
9ae3a8
BZ: 1033490
9ae3a8
9ae3a8
This test creates an image with unallocated zero clusters, then creates
9ae3a8
a snapshot. Afterwards, there should be neither any errors nor leaks.
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
(cherry picked from commit 449df7063815489a0b091bcb3afa9ae80ae3acbf)
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
9ae3a8
Conflicts:
9ae3a8
	tests/qemu-iotests/group
9ae3a8
---
9ae3a8
 tests/qemu-iotests/062     | 64 ++++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/062.out |  9 +++++++
9ae3a8
 tests/qemu-iotests/group   |  1 +
9ae3a8
 3 files changed, 74 insertions(+)
9ae3a8
 create mode 100755 tests/qemu-iotests/062
9ae3a8
 create mode 100644 tests/qemu-iotests/062.out
9ae3a8
9ae3a8
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/062     |   64 ++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/062.out |    9 ++++++
9ae3a8
 tests/qemu-iotests/group   |    1 +
9ae3a8
 3 files changed, 74 insertions(+), 0 deletions(-)
9ae3a8
 create mode 100644 tests/qemu-iotests/062
9ae3a8
 create mode 100644 tests/qemu-iotests/062.out
9ae3a8
9ae3a8
diff --git a/tests/qemu-iotests/062 b/tests/qemu-iotests/062
9ae3a8
new file mode 100644
9ae3a8
index 0000000..0511246
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/062
9ae3a8
@@ -0,0 +1,64 @@
9ae3a8
+#!/bin/bash
9ae3a8
+#
9ae3a8
+# Test case for snapshotting images with unallocated zero clusters in
9ae3a8
+# qcow2
9ae3a8
+#
9ae3a8
+# Copyright (C) 2013 Red Hat, Inc.
9ae3a8
+#
9ae3a8
+# This program is free software; you can redistribute it and/or modify
9ae3a8
+# it under the terms of the GNU General Public License as published by
9ae3a8
+# the Free Software Foundation; either version 2 of the License, or
9ae3a8
+# (at your option) any later version.
9ae3a8
+#
9ae3a8
+# This program is distributed in the hope that it will be useful,
9ae3a8
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
9ae3a8
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
9ae3a8
+# GNU General Public License for more details.
9ae3a8
+#
9ae3a8
+# You should have received a copy of the GNU General Public License
9ae3a8
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
9ae3a8
+#
9ae3a8
+
9ae3a8
+# creator
9ae3a8
+owner=mreitz@redhat.com
9ae3a8
+
9ae3a8
+seq=`basename $0`
9ae3a8
+echo "QA output created by $seq"
9ae3a8
+
9ae3a8
+here=`pwd`
9ae3a8
+tmp=/tmp/$$
9ae3a8
+status=1	# failure is the default!
9ae3a8
+
9ae3a8
+_cleanup()
9ae3a8
+{
9ae3a8
+	_cleanup_test_img
9ae3a8
+}
9ae3a8
+trap "_cleanup; exit \$status" 0 1 2 3 15
9ae3a8
+
9ae3a8
+# get standard environment, filters and checks
9ae3a8
+. ./common.rc
9ae3a8
+. ./common.filter
9ae3a8
+
9ae3a8
+# This tests qocw2-specific low-level functionality
9ae3a8
+_supported_fmt qcow2
9ae3a8
+_supported_proto generic
9ae3a8
+_supported_os Linux
9ae3a8
+
9ae3a8
+IMGOPTS="compat=1.1"
9ae3a8
+IMG_SIZE=64M
9ae3a8
+
9ae3a8
+echo
9ae3a8
+echo "=== Testing snapshotting an image with zero clusters ==="
9ae3a8
+echo
9ae3a8
+_make_test_img $IMG_SIZE
9ae3a8
+# Write some zero clusters
9ae3a8
+$QEMU_IO -c "write -z 0 256k" "$TEST_IMG" | _filter_qemu_io
9ae3a8
+# Create a snapshot
9ae3a8
+$QEMU_IMG snapshot -c foo "$TEST_IMG"
9ae3a8
+# Check the image (there shouldn't be any errors or leaks)
9ae3a8
+_check_test_img
9ae3a8
+
9ae3a8
+# success, all done
9ae3a8
+echo "*** done"
9ae3a8
+rm -f $seq.full
9ae3a8
+status=0
9ae3a8
diff --git a/tests/qemu-iotests/062.out b/tests/qemu-iotests/062.out
9ae3a8
new file mode 100644
9ae3a8
index 0000000..442d761
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/062.out
9ae3a8
@@ -0,0 +1,9 @@
9ae3a8
+QA output created by 062
9ae3a8
+
9ae3a8
+=== Testing snapshotting an image with zero clusters ===
9ae3a8
+
9ae3a8
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=67108864 
9ae3a8
+wrote 262144/262144 bytes at offset 0
9ae3a8
+256 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+No errors were found on the image.
9ae3a8
+*** done
9ae3a8
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
9ae3a8
index 0867b0f..2d0aba0 100644
9ae3a8
--- a/tests/qemu-iotests/group
9ae3a8
+++ b/tests/qemu-iotests/group
9ae3a8
@@ -63,6 +63,7 @@
9ae3a8
 054 rw auto
9ae3a8
 059 rw auto
9ae3a8
 060 rw auto
9ae3a8
+062 rw auto
9ae3a8
 063 rw auto
9ae3a8
 064 rw auto
9ae3a8
 065 rw auto
9ae3a8
-- 
9ae3a8
1.7.1
9ae3a8